import java.lang.*;
import java.util.*;

public class Mapy
 { static HashSet <String> hashset=new HashSet <String>();
   static TreeSet <String> treeset=new TreeSet<String>();
   static HashMap <String,String> hashmap=new HashMap<String,String>();
   static TreeMap <String,String> treemap=new TreeMap<String,String>();
   
   static public byte[] wypelnij(int n)
    { byte tablica1[]=new byte[n];
      Random r=new Random(n);
      for (int i=0; i<tablica1.length;i++) 
        tablica1[i]=(byte)(65+r.nextInt(26));
        return tablica1;
    }
   
   static String klucz2(int n)
    { return new String(wypelnij(n)); }  
   
   static public void wypelnij3(int n)
    { for (int i=0; i<n;i++) 
       { String s=new String(wypelnij(i+1));
       	  hashset.add(s);
       }
     }
     
    static public void wypelnij4(int n)
    { for (int i=0; i<n;i++) 
       { String s=new String(wypelnij(i+1));
       	  treeset.add(s);
       }
     }
     
    static public void wypelnij5(int n)
    { for (int i=0; i<n;i++) 
       { String s1=new String(wypelnij(2*i+1));
         String s2=new String(wypelnij(i+1));
         hashmap.put(s1,s2);
       }
     }
     
    static public void wypelnij6(int n)
    { for (int i=0; i<n;i++) 
       { String s1=new String(wypelnij(2*i+1));
         String s2=new String(wypelnij(i+1));
         treemap.put(s1,s2);
       }
     }

 static <K, V> Map<K, V> sumamap(Map<K, V>pierwsza, 
                                Map<K, V> druga) 
 { Map<K, V> sumamap_ = new HashMap<K, V>(pierwsza);
   sumamap_.putAll(druga);
   return sumamap_;}


  static <K, V> Set<K>  walidacja(Map<K, V> podstawowa,
                                  Set<K> wzorzec) 
   {Set<K> zle = new TreeSet<K>(wzorzec);
    Set<K> klucze = podstawowa.keySet();
    if(!klucze.containsAll(wzorzec)) {
        zle.retainAll(klucze);      
    }  
    return zle;
}

 
  public static void main(String args[])
    { 
      wypelnij3(10);wypelnij3(10);
      wypelnij4(10);wypelnij4(10);
      wypelnij5(5);wypelnij5(5);
      wypelnij6(10);wypelnij6(10);
      System.out.println("\nhashset\n"+hashset.toString());
      System.out.println("\ntreeset\n"+treeset.toString());
      System.out.println("\nhashmap\n"+hashmap.toString());
      System.out.println("\ntreemap\n"+treemap.toString());        
      String a=klucz2(5);
      boolean b1=hashmap.containsKey(a);
      System.out.println(b1+", ze znaleziono w HashMap klucz "+a);
      boolean b2=hashmap.containsValue(a);
      System.out.println(b2+", ze znaleziono w HashMap wartosc "+a);
      b1=treemap.containsKey(a);
      System.out.println(b1+", ze znaleziono w TreeMap klucz "+a);
      b2=treemap.containsValue(a);
      System.out.println(b2+", ze znaleziono w TreeMap wartosc "+a);
      Map <String, String> sumamap_ = sumamap(treemap,hashmap);
      System.out.println("\nsuma map 1\n"+sumamap_.toString()); 
      sumamap_ = sumamap(hashmap,treemap);
      System.out.println("\nsuma map 2\n"+sumamap_.toString());   
      //zbior klucze_walidacji zawieraja te klucze, ktore sa jednoczesnie w zbiorze kluczy treemap i hashset
      Set <String>klucze_walidacji=walidacja(treemap,hashset);
      System.out.println("\nwynik walidacji\n"+klucze_walidacji.toString());
      System.out.println("Wynik porownania zbioru kluczy w TreeMap i HashMap:"+treemap.keySet().equals(hashmap.keySet()));
     }
 }